#!/usr/bin/perl

#
# Mal's e-commerce
# Form to email processor
#
# This simple script is designed to take the
# remote HTTP link from the cart and send an email
# to the customer.
#

$| = 1;

# Path to send mail instead by uncommenting this line
$SEND_MAIL="/usr/sbin/sendmail -t";

# The email's subject line
$subject = "Order receipt";

# Your email address
# The backslash before the @ in the address is IMPORTANT!
$sender = "ms\@ait2000.net";


# This part takes the incomming query string and
# parses it into seperate fields with the names
# $Data{'field_name'}

@pairs = split(/&/, $ENV{'QUERY_STRING'});
    # For each name-value pair:
    foreach $pair (@pairs) {

		# Split the pair up into individual variables.
		local($name, $value) = split(/=/, $pair);
	 
		# Decode the form encoding on the name and value variables.
		$name =~ tr/+/ /;
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	
	    if ($value) {
			$Data{$name} = $value;
	    }
    }

# Output a header. We must do this!
print "Content-type: text/html\n\n";

# If there is no recipient for the message
# then stop here
if ( ! $Data{'email'} ) {
    print "No sender email address";
    exit;
}

# The cart is delimited by ~ between lines so
# replace these with a \n new line
$cart = "";
@lines = split(/~/, $Data{'cart'});
foreach $item (@lines) {
    $cart .= $item . "\n"; 
}

# We build up the body of the message
$message = "\nThank you for your order.

Username    : $Data{'username'}
Customer ID : $Data{'id'}
Date        : $Data{'date'}
For payment by $Data{'method'}

Product , Quantity , Price 
==========================
$cart

Discount : -$Data{'discount'}
Subtotal :  $Data{'subtotal'}
Shipping :  $Data{'shipping'}
Tax      :  $Data{'tax'}
         -------------
TOTAL    :  $Data{'total'}

Invoice To:
$Data{'inv_name'}
$Data{'inv_company'}
$Data{'inv_addr1'}
$Data{'inv_addr2'}
$Data{'inv_state'}
$Data{'inv_zip'}
$Data{'inv_country'}
$Data{'tel'}
$Data{'fax'}
$Data{'email'}

Ship To:
$Data{'del_name'}
$Data{'del_addr1'}
$Data{'del_addr2'}
$Data{'del_state'}
$Data{'del_zip'}
$Data{'del_country'}

If you have any questions about your order please do not hesitate
to contact us.
";

# There are two extra fields that are not included in this sample
# they are Data{'message'} and Data{'ip'}.

#  And this actually sends the email
if ($SEND_MAIL ne "")
{
    open (MAIL,"| $SEND_MAIL");
   
    print MAIL "To: $Data{'email'}\n";
    print MAIL "From: $sender\n";
    print MAIL "Reply-to: $sender\n";
    print MAIL "X-Mailer: Perl Powered Socket Mailer\n";
    print MAIL "Subject: $subject\n\n";
    print MAIL "$message";
    print MAIL "\n.\n";
    
    close(MAIL);
}

# Confirmation - Dont' cut this off, it lets my server
# know that the transfer is finished
print "Success<br>Sent to $Data{'email'}\n";

# End of script!


